<template>
	<div class="flex flex-row p-2 mb-3 rounded-md bg-white text-gray animate__animated animate__fadeInRight" v-if="currentRequirement.status">
		<i class="flex-shrink leading-tight px-2 text-lg" :class="iconClass"></i>
		<p class="flex-1 leading-tight text-lg">{{ currentRequirement.label }}</p>
	</div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";
import axios from 'axios';

export default {
	name: "CheckItem",
	props: {
		type: {
			type: String,
			required: true,
		},
		index: {
			type: Number,
			default: 0
		}
	},
	computed: {
		...mapGetters([
			'requirement'
		]),
		currentRequirement(){
			return this.requirement(this.type);
		},
		iconClass(){
			if(this.currentRequirement.status === 'success'){
				return 'far fa-check-circle text-green-900';
			}else if(this.currentRequirement.status === 'error'){
				return 'far fa-times-circle text-red-900';
			}else if(this.currentRequirement.status === 'loading'){
				return 'fas fa-spinner fa-spin text-blue';
			}
		}
	},
	methods: {
		...mapActions([
			'setRequirementStatus'
		]),
		check(){
			let multiplier = process.env.NODE_ENV === 'development' ? 100 : 500; // TODO: DEBUG
			if(!this.currentRequirement.status){ // TODO: DEBUG
				setTimeout(() => {
					this.setRequirementStatus({type: this.type, status: 'loading'})
					setTimeout(() => {
						axios.post('/install.php', {
							handler: 'onCheckRequirements',
							payload: this.type
						})
							.then(({data}) => {
								console.log(data);
								this.setRequirementStatus({type: this.type, status: data.status ? 'success' : 'error'})
							});
					}, 1000)
				}, this.index * multiplier);
			}
		}
	},
	created() {
		this.check();
	}
}
</script>

<style scoped>

</style>